dnl $Id$
dnl config.m4 for extension sdl

PHP_ARG_WITH( sdl, for sdl support, [  --with-sdl=DIR          Include sdl support ] )

if test "$PHP_SDL" != "no"; then

	if test "$PHP_SDL" = "yes"; then
		SDL_LIST="/usr/local /usr"
	else
		SDL_LIST="$PHP_SDL /usr/local /usr"
	fi
	SDL_SUBLIST="none 12 11"
	SDL_CONFIG=""

	AC_MSG_CHECKING(for sdl-config)
	for i in $SDL_LIST; do
		for j in $SDL_SUBLIST; do
			if test "x$j" = "xnone"; then
				tmp=""
			else
				tmp=$j
			fi
			if test -x "$i/bin/sdl$tmp-config"; then
				SDL_CONFIG="$i/bin/sdl$tmp-config"
			fi
		done
		if test -n "$SDL_CONFIG"; then
			break
		fi
	done

	if test -n "$SDL_CONFIG"; then
		AC_MSG_RESULT(found in $SDL_CONFIG)

		PHP_EVAL_INCLINE(`$SDL_CONFIG --cflags`)

		dnl FIXME: support non-shared builds
		SDL_LIBS=`$SDL_CONFIG --libs`
		for i in $SDL_LIBS; do
			case $i in
				-L*)
					tmp=`echo $i | cut -c 3-`
					PHP_ADD_LIBPATH($tmp, SDL_SHARED_LIBADD)
					;;
				-l*)
					tmp=`echo $i | cut -c 3-`
					PHP_ADD_LIBRARY($tmp, 1, SDL_SHARED_LIBADD)
					;;
			esac
		done
	else
		AC_MSG_RESULT([not found, trying manual way])

		AC_MSG_CHECKING(for SDL/SDL.h)

		SDL_DIR=""
		SDL_VER=""
		for i in $SDL_LIST; do
			if test -f "$i/include/SDL/SDL.h"; then
				SDL_DIR=$i
				SDL_VER=$tmp
			fi
			if test -n "$SDL_DIR"; then
				break
			fi
		done

		if test -z "$SDL_DIR"; then
			AC_MSG_ERROR(not found in $SDL_LIST)
		else
			AC_MSG_RESULT(found below $SDL_DIR/include)
		fi

		if test ! -f "$i/lib/libSDL.so"; then
			AC_MSG_ERROR(Cannot find lib/libSDL.so below $i)
		fi

		PHP_ADD_INCLUDE($SDL_DIR/include/SDL)
	fi

	PHP_NEW_EXTENSION( sdl, php_sdl.c php_sdl_audio.c php_sdl_event.c php_sdl_thread.c php_sdl_wm.c php_sdl_cdrom.c php_sdl_joystick.c php_sdl_time.c, $ext_shared )
	
	AC_DEFINE(HAVE_SDL, 1, [ ])
fi

